from ariadne import QueryType

from bot_data.service.server_repository_service import ServerRepositoryService
from bot_graphql.abc.filter_abc import FilterABC
from bot_graphql.filter.server_filter import ServerFilter


class Query(QueryType):
    def __init__(self, servers: ServerRepositoryService):
        QueryType.__init__(self)
        self._servers = servers

        self.set_field("servers", self.resolve_servers)
        self.set_field("server_count", self.resolve_server_count)

    @FilterABC.resolve_filter_annotation
    def resolve_servers(self, *_, filter: ServerFilter = None):
        if filter is not None:
            return filter.filter(self._servers.get_servers())
        else:
            return self._servers.get_servers()

    def resolve_server_count(self, *_):
        return self._servers.get_servers().count()
